
%define docver  2.7.9
%define dirver  2.7

%define lib_major       %{dirver}
%define lib_name_orig   libpython
%define lib_name        %mklibname %{name} %{lib_major}
%define dev_name        %mklibname %{name} -d

Summary:        An interpreted, interactive object-oriented programming language
Name:           python
Version:        2.7.9
Release:        %mkrel 7
License:        Modified CNRI Open Source License
Group:          Development/Python
Url:            http://www.python.org/
Source0:        http://www.python.org/ftp/python/%{version}/Python-%{version}.tar.xz
Source1:        http://www.python.org/ftp/python/doc/%{docver}/python-%{docver}-docs-html.tar.bz2
Source4:        python-mode-1.0.tar.bz2
Patch0:         python-2.7.5-module-linkage.patch
Patch3:         Python-2.7.6-no-local-incpath.patch
Patch4:         python-lib64.patch
Patch5:         Python-2.2.2-biarch-headers.patch
Patch10:        python-2.5.1-detect-distribution.patch
Patch16:        python-2.5.1-plural-fix.patch
Patch23:        python-2.7-mips-ffi.patch
Patch24:        python_arch.patch
Patch25:        python-2.7.5-skip-shm-test.patch 
Patch130:       Python-2.7.5-check-for-XML_SetHashSalt.diff
Patch173:       00173-workaround-ENOPROTOOPT-in-bind_port.patch
Requires:       %{lib_name} = %{version}

#----------------------------------------------
BuildRequires:  blt
BuildRequires:  emacs-bin
BuildRequires:  gdbm-devel
BuildRequires:  gmp-devel
BuildRequires:  ncursesw-devel
BuildRequires:  openssl-devel
BuildRequires:  readline-devel
BuildRequires:  termcap-devel
BuildRequires:  tk-devel
BuildRequires:  tix
BuildRequires:  autoconf2.5
BuildRequires:  bzip2-devel
BuildRequires:  sqlite3-devel
BuildRequires:  emacs

BuildRequires:  %{_lib}db4.8-devel
BuildRequires:  %{_lib}expat1-devel
BuildRequires:  %{_lib}ffi-devel

BuildConflicts: python-pyxml
#----------------------------------------------

Provides:       python(abi) = %dirver
Obsoletes:      python-ctypes
Provides:       python-ctypes
Obsoletes:      python-elementtree
Provides:       python-elementtree
Obsoletes:      python-base < 2.6
Provides:       python-base = %version


%description
Python is an interpreted, interactive, object-oriented programming
language often compared to Tcl, Perl, Scheme or Java. Python includes
modules, classes, exceptions, very high level dynamic data types and
dynamic typing. Python supports interfaces to many system calls and
libraries, as well as to various windowing systems (X11, Motif, Tk,
Mac and MFC).

Programmers can write new built-in modules for Python in C or C++.
Python can be used as an extension language for applications that
need a programmable interface. This package contains most of the
standard Python modules, as well as modules for interfacing to the
Tix widget set for Tk and RPM.

Note that documentation for Python is provided in the python-docs
package.

%package -n     %{lib_name}
Summary:        Shared libraries for Python %{version}
Group:          Development/Python

%description -n %{lib_name}
This packages contains Python shared object library.  Python is an
interpreted, interactive, object-oriented programming language often
compared to Tcl, Perl, Scheme or Java.

%package -n     %{dev_name}
Summary:        The libraries and header files needed for Python development
Group:          Development/Python
Requires:       %{name} = %version
Requires:       %{lib_name} = %{version}
Requires:	python-rpm-macros
Requires:	python2-rpm-macros
Obsoletes:      %{name}-devel < %{version}
Obsoletes:      %mklibname -d %{name} 2.6
Provides:       %{name}-devel = %{version}-%{release}
Provides:       %{lib_name_orig}-devel = %{version}-%{release}

%description -n %{dev_name}
The Python programming language's interpreter can be extended with
dynamically loaded extensions and can be embedded in other programs.
This package contains the header files and libraries needed to do
these types of tasks.

Install %{dev_name} if you want to develop Python extensions.  The
python package will also need to be installed.  You'll probably also
want to install the python-docs package, which contains Python
documentation.

%package        docs
Summary:        Documentation for the Python programming language
Requires:       python = %version
Requires:       xdg-utils
Group:          Documentation
BuildArch:      noarch

%description    docs
The python-docs package contains documentation on the Python
programming language and interpreter.  The documentation is provided
in ASCII text files and in LaTeX source files.

Install the python-docs package if you'd like to use the documentation
for the Python language.

%package -n     tkinter
Summary:        A graphical user interface for the Python scripting language
Group:          Development/Python
Obsoletes:	tkinter < %version
Requires:       python = %version
Requires:       tcl tk

%description -n tkinter
The Tkinter (Tk interface) program is an graphical user interface for
the Python scripting language.

You should install the tkinter package if you'd like to use a graphical
user interface for Python programming.

%package -n     tkinter-apps
Summary:        Various applications written using tkinter
Group:          Development/Python
Obsoletes:	tkinter-apps < %version
Requires:       tkinter

%description -n tkinter-apps
Various applications written using tkinter

%prep
%setup -q -n Python-%{version}
%patch0 -p0
%patch3 -p0
%patch4 -p0 -b .lib64
%patch5 -p0
%patch10 -p0
%patch16 -p1 -b .plural-fix
%patch23 -p1 -b .mips
%patch24 -p1 -b .arch
%patch25 -p1
%patch130 -p1 -b .check-for-XML_SetHashSalt
%patch173 -p1

autoconf

mkdir html
bzcat %{SOURCE1} | tar x  -C html
find html -type d |xargs chmod 755
find html -type f |xargs chmod 644

find . -type f -print0 | xargs -0 perl -p -i -e 's@/usr/local/bin/python@/usr/bin/python@'

tar --strip-components=1 -xjf %{SOURCE4} -C Misc

cat > README.pclos << EOF
Python interpreter support readline completion by default.
This is only used with the interpreter. In order to remove it,
you can :
1) unset PYTHONSTARTUP when you login
2) create a empty file \$HOME/.pythonrc.py
3) change %{_sysconfdir}/pythonrc.py
EOF
# make sur the IN.py TYPES.py and DLFCN.py are correct
# for current arch otherwise things will start failing
# in weird ways
pushd Lib/plat-linux2/
../../Tools/scripts/h2py.py -i '(u_long)' /usr/include/sys/types.h /usr/include/netinet/in.h /usr/include/dlfcn.h
popd

%build
rm -f Modules/Setup.local
cat > Modules/Setup.local << EOF
linuxaudiodev linuxaudiodev.c
EOF

OPT="$RPM_OPT_FLAGS -g"
export OPT

export CFLAGS="%{optflags} -I/usr/include/ncursesw"
export CPPFLAGS="%{optflags} -I/usr/include/ncursesw"
%define _disable_ld_no_undefined 1

%configure2_5x  --with-threads \
        --enable-unicode=ucs4 \
        --with-dbmliborder=gdbm \
        --enable-ipv6 \
        --enable-shared \
        --with-system-expat \
        --with-system-ffi

export TMP="/tmp" TMPDIR="/tmp"
make


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p %buildroot%{_prefix}/lib/python%{dirver}

perl -pi -e "/^CC=/ and s/distcc/gcc/" Makefile

# set the install path
echo '[install_scripts]' >setup.cfg
echo 'install_dir='"${RPM_BUILD_ROOT}/usr/bin" >>setup.cfg

# python is not GNU and does not know fsstd
mkdir -p $RPM_BUILD_ROOT%{_mandir}
%makeinstall_std

(cd $RPM_BUILD_ROOT%{_libdir}; ln -sf libpython%{lib_major}.so.* libpython%{lib_major}.so)

(cd $RPM_BUILD_ROOT%{_libdir}/python%{dirver}/config; ln -sf ../../libpython%{lib_major}.so .)

# emacs, I use it, I want it
mkdir -p $RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp
install -m 644 Misc/python-mode.el $RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp
emacs -batch -f batch-byte-compile $RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp/python-mode.el

install -d $RPM_BUILD_ROOT%{_sysconfdir}/emacs/site-start.d
cat <<EOF >$RPM_BUILD_ROOT%{_sysconfdir}/emacs/site-start.d/%{name}.el
(setq auto-mode-alist (cons '("\\\\.py$" . python-mode) auto-mode-alist))
(autoload 'python-mode "python-mode" "Mode for python files." t)
EOF

#"  this comment is just here because vim syntax higlighting is confused by the previous snippet of lisp

# smtpd proxy
mv -f $RPM_BUILD_ROOT%{_bindir}/smtpd.py $RPM_BUILD_ROOT%{_libdir}/python%{dirver}/

# idle
cp Tools/scripts/idle $RPM_BUILD_ROOT%{_bindir}/idle


# pynche
cat << EOF > $RPM_BUILD_ROOT%{_bindir}/pynche
#!/bin/bash
exec %{_libdir}/python%{dirver}/site-packages/pynche/pynche
EOF
rm -f Tools/pynche/*.pyw
cp -r Tools/pynche $RPM_BUILD_ROOT%{_libdir}/python%{dirver}/site-packages/

chmod 755 $RPM_BUILD_ROOT%{_bindir}/{idle,pynche}

ln -f Tools/pynche/README Tools/pynche/README.pynche

%if %{with valgrind}
install Misc/valgrind-python.supp -D $RPM_BUILD_ROOT%{_libdir}/valgrind/valgrind-python.supp
%endif

mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
cat > $RPM_BUILD_ROOT%{_datadir}/applications/tkinter.desktop << EOF
[Desktop Entry]
Name=IDLE
Comment=IDE for Python
Exec=%{_bindir}/idle
Icon=development_environment_section
Terminal=false
Type=Application
Categories=Development;IDE;
EOF


cat > $RPM_BUILD_ROOT%{_datadir}/applications/%{name}-docs.desktop << EOF
[Desktop Entry]
Name=Python documentation
Comment=Python complete reference
Exec=%{_bindir}/xdg-open %_defaultdocdir/%{name}-docs/index.html
Icon=documentation_section
Terminal=false
Type=Application
Categories=Documentation;
EOF


# fix non real scripts
chmod 644 $RPM_BUILD_ROOT%{_libdir}/python*/test/test_{binascii,grp,htmlparser}.py*
# fix python library not stripped
chmod u+w $RPM_BUILD_ROOT%{_libdir}/libpython%{lib_major}.so.1.0


mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/

cat > $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/30python.sh << 'EOF'
if [ -f $HOME/.pythonrc.py ] ; then
        export PYTHONSTARTUP=$HOME/.pythonrc.py
else
        export PYTHONSTARTUP=/etc/pythonrc.py
fi

export PYTHONDONTWRITEBYTECODE=1
EOF

cat > $RPM_BUILD_ROOT/%{_sysconfdir}/profile.d/30python.csh << 'EOF'
if ( -f ${HOME}/.pythonrc.py ) then
        setenv PYTHONSTARTUP ${HOME}/.pythonrc.py
else
        setenv PYTHONSTARTUP /etc/pythonrc.py
endif
setenv PYTHONDONTWRITEBYTECODE 1
EOF

cat > $RPM_BUILD_ROOT%{_sysconfdir}/pythonrc.py << EOF
try:
    # this add completion to python interpreter
    import readline
    import rlcompleter
    # see readline man page for this
    readline.parse_and_bind("set show-all-if-ambiguous on")
    readline.parse_and_bind("tab: complete")
except:
    pass
# you can place a file .pythonrc.py in your home to overrides this one
# but then, this file will not be sourced
EOF

%multiarch_includes $RPM_BUILD_ROOT/usr/include/python*/pyconfig.h

%files
%defattr(-, root, root)
%doc README.pclos
%config(noreplace) %{_sysconfdir}/emacs/site-start.d/%{name}.el
%{_sysconfdir}/profile.d/*
%config(noreplace) %{_sysconfdir}/pythonrc.py
%dir %{_libdir}/python%{dirver}/config
%{_libdir}/python%{dirver}/config/Makefile
%dir %{_includedir}/python%{dirver}
%{_includedir}/python%{dirver}/pyconfig.h
%multiarch %multiarch_includedir/python%{dirver}/pyconfig.h

%exclude %{_libdir}/python%{dirver}/config/Setup
%exclude %{_libdir}/python%{dirver}/config/Setup.config
%exclude %{_libdir}/python%{dirver}/config/Setup.local
%exclude %{_libdir}/python%{dirver}/config/config.c
%exclude %{_libdir}/python%{dirver}/config/config.c.in
%exclude %{_libdir}/python%{dirver}/config/install-sh
%exclude %{_libdir}/python%{dirver}/config/libpython2.7.a
%exclude %{_libdir}/python%{dirver}/config/libpython2.7.so
%exclude %{_libdir}/python%{dirver}/config/makesetup
%exclude %{_libdir}/python%{dirver}/config/python.o
%exclude %{_libdir}/python%{dirver}/test/
%exclude %{_libdir}/python%{dirver}/idlelib
%exclude %{_libdir}/python%{dirver}/lib-tk
%exclude %{_libdir}/python%{dirver}/lib-dynload/_tkinter.so
%exclude %{_libdir}/python%{dirver}/site-packages/pynche

%{_libdir}/python%{dirver}
%if "%{_lib}" != "lib"
%{_prefix}/lib/python%{dirver}
%endif
%{_bindir}/python2
%{_bindir}/python%{dirver}
%{_bindir}/pydoc
%{_bindir}/python
%{_bindir}/2to3
%{_datadir}/emacs/site-lisp/*
%{_mandir}/man*/*
%if %{with valgrind}
%{_libdir}/valgrind/valgrind-python.supp
%endif

%files -n %{lib_name}
%defattr(-, root, root)
%{_libdir}/libpython*.so.1*

%files -n %{dev_name}
%defattr(-, root, root)
%{_libdir}/libpython*.so
%{_libdir}/pkgconfig/*.pc
%{_includedir}/python%{dirver}
%{_libdir}/python%{dirver}/config/*
%{_libdir}/python%{dirver}/test/
%{_bindir}/python%{dirver}-config
%{_bindir}/python-config
%{_bindir}/python2-config
%exclude %{_libdir}/python%{dirver}/config/Makefile
%exclude %{_includedir}/python%{dirver}/pyconfig.h

%files docs
%defattr(-, root, root)
%doc html/*/*
%{_datadir}/applications/%{name}-docs.desktop

%files -n tkinter
%defattr(-, root, root)
%dir %{_libdir}/python%{dirver}/lib-tk
%{_libdir}/python%{dirver}/lib-tk/*.py*
%{_libdir}/python%{dirver}/lib-tk/test/
%{_libdir}/python%{dirver}/lib-dynload/_tkinter.so
%{_libdir}/python%{dirver}/idlelib
%{_libdir}/python%{dirver}/site-packages/pynche

%files -n tkinter-apps
%defattr(-, root, root)
%{_bindir}/idle
%{_bindir}/pynche
%{_datadir}/applications/tkinter.desktop

%posttrans
#clean out this junk folder
rm -rf %{_libdir}/python2.7/site-packages/_xmlplus

%clean 
rm -rf $RPM_BUILD_ROOT

%changelog
* Mon Nov 06 2017 bb2 <bb2> - 2.7.9-7pclos2017
- rebuild against updates

* Mon Aug 14 2017 bb2 <bb2> - 2.7.9-6pclos2017
- rebuild against updates

* Fri Jul 22 2016 bb <bb> 2.7.9-5pclos2016
- rebuild new libffi

* Wed Mar 23 2016 bb <bb> 2.7.9-4pclos2016
- clean out dead folder

* Sat Mar 19 2016 bb <bb> 2.7.9-3pclos2016
- require python rpm macros package for
- python-devel package


